/* Session.c generated by valac 0.38.10, the Vala compiler
 * generated from Session.vala, do not modify */

/*-
 * Copyright (c) 2015 Wingpanel Developers (http://launchpad.net/wingpanel)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* This class is meant to remember the
 * notifications from the current session
 * and restore them in the next session.
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>


#define NOTIFICATIONS_TYPE_SESSION (notifications_session_get_type ())
#define NOTIFICATIONS_SESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOTIFICATIONS_TYPE_SESSION, NotificationsSession))
#define NOTIFICATIONS_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOTIFICATIONS_TYPE_SESSION, NotificationsSessionClass))
#define NOTIFICATIONS_IS_SESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOTIFICATIONS_TYPE_SESSION))
#define NOTIFICATIONS_IS_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOTIFICATIONS_TYPE_SESSION))
#define NOTIFICATIONS_SESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOTIFICATIONS_TYPE_SESSION, NotificationsSessionClass))

typedef struct _NotificationsSession NotificationsSession;
typedef struct _NotificationsSessionClass NotificationsSessionClass;
typedef struct _NotificationsSessionPrivate NotificationsSessionPrivate;
enum  {
	NOTIFICATIONS_SESSION_0_PROPERTY,
	NOTIFICATIONS_SESSION_NUM_PROPERTIES
};
static GParamSpec* notifications_session_properties[NOTIFICATIONS_SESSION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define NOTIFICATIONS_TYPE_NOTIFICATION (notifications_notification_get_type ())
#define NOTIFICATIONS_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotification))
#define NOTIFICATIONS_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotificationClass))
#define NOTIFICATIONS_IS_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOTIFICATIONS_TYPE_NOTIFICATION))
#define NOTIFICATIONS_IS_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOTIFICATIONS_TYPE_NOTIFICATION))
#define NOTIFICATIONS_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOTIFICATIONS_TYPE_NOTIFICATION, NotificationsNotificationClass))

typedef struct _NotificationsNotification NotificationsNotification;
typedef struct _NotificationsNotificationClass NotificationsNotificationClass;
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NotificationsNotificationPrivate NotificationsNotificationPrivate;

struct _NotificationsSession {
	GObject parent_instance;
	NotificationsSessionPrivate * priv;
};

struct _NotificationsSessionClass {
	GObjectClass parent_class;
};

struct _NotificationsSessionPrivate {
	GFile* session_file;
	GKeyFile* key;
};

struct _NotificationsNotification {
	GObject parent_instance;
	NotificationsNotificationPrivate * priv;
	gboolean data_session;
	gchar* app_name;
	gchar* summary;
	gchar* message_body;
	gchar* app_icon;
	gchar* sender;
	gchar** actions;
	gint actions_length1;
	GVariant* hints;
	gint32 expire_timeout;
	guint32 replaces_id;
	guint32 id;
	guint32 pid;
	GDateTime* timestamp;
	gint64 unix_time;
	gchar* desktop_id;
	GAppInfo* app_info;
};

struct _NotificationsNotificationClass {
	GObjectClass parent_class;
};


static gpointer notifications_session_parent_class = NULL;
static NotificationsSession* notifications_session_instance;
static NotificationsSession* notifications_session_instance = NULL;

GType notifications_session_get_type (void) G_GNUC_CONST;
#define NOTIFICATIONS_SESSION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NOTIFICATIONS_TYPE_SESSION, NotificationsSessionPrivate))
#define NOTIFICATIONS_SESSION_SESSION_FILE_NAME ".notifications.session"
#define NOTIFICATIONS_SESSION_APP_NAME_KEY "AppName"
#define NOTIFICATIONS_SESSION_APP_ICON_KEY "AppIcon"
#define NOTIFICATIONS_SESSION_SUMMARY_KEY "Summary"
#define NOTIFICATIONS_SESSION_BODY_KEY "Body"
#define NOTIFICATIONS_SESSION_ACTIONS_KEY "Actions"
#define NOTIFICATIONS_SESSION_DESKTOP_ID_KEY "DesktopID"
#define NOTIFICATIONS_SESSION_UNIX_TIME_KEY "UnixTime"
#define NOTIFICATIONS_SESSION_SENDER_KEY "Sender"
NotificationsSession* notifications_session_get_instance (void);
static NotificationsSession* notifications_session_new (void);
static NotificationsSession* notifications_session_construct (GType object_type);
static void notifications_session_create_session_file (NotificationsSession* self);
GType notifications_notification_get_type (void) G_GNUC_CONST;
GList* notifications_session_get_session_notifications (NotificationsSession* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
NotificationsNotification* notifications_notification_new_from_data (guint32 _id, const gchar* _app_name, const gchar* _app_icon, const gchar* _summary, const gchar* _message_body, gchar** _actions, int _actions_length1, const gchar* _desktop_id, gint64 _unix_time, const gchar* _sender);
NotificationsNotification* notifications_notification_construct_from_data (GType object_type, guint32 _id, const gchar* _app_name, const gchar* _app_icon, const gchar* _summary, const gchar* _message_body, gchar** _actions, int _actions_length1, const gchar* _desktop_id, gint64 _unix_time, const gchar* _sender);
void notifications_session_add_notification (NotificationsSession* self, NotificationsNotification* notification);
static void notifications_session_write_contents (NotificationsSession* self);
void notifications_session_remove_notification (NotificationsSession* self, NotificationsNotification* notification);
void notifications_session_clear (NotificationsSession* self);
static void notifications_session_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


NotificationsSession* notifications_session_get_instance (void) {
	NotificationsSession* result = NULL;
	NotificationsSession* _tmp0_;
	NotificationsSession* _tmp2_;
	NotificationsSession* _tmp3_;
	_tmp0_ = notifications_session_instance;
	if (_tmp0_ == NULL) {
		NotificationsSession* _tmp1_;
		_tmp1_ = notifications_session_new ();
		_g_object_unref0 (notifications_session_instance);
		notifications_session_instance = _tmp1_;
	}
	_tmp2_ = notifications_session_instance;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	result = _tmp3_;
	return result;
}


static NotificationsSession* notifications_session_construct (GType object_type) {
	NotificationsSession * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gboolean _tmp5_;
	GKeyFile* _tmp6_;
	GKeyFile* _tmp7_;
	self = (NotificationsSession*) g_object_new (object_type, NULL);
	_tmp0_ = g_get_user_cache_dir ();
	_tmp1_ = g_build_filename (_tmp0_, NOTIFICATIONS_SESSION_SESSION_FILE_NAME, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_file_new_for_path (_tmp2_);
	_g_object_unref0 (self->priv->session_file);
	self->priv->session_file = _tmp3_;
	_g_free0 (_tmp2_);
	_tmp4_ = self->priv->session_file;
	_tmp5_ = g_file_query_exists (_tmp4_, NULL);
	if (!_tmp5_) {
		notifications_session_create_session_file (self);
	}
	_tmp6_ = g_key_file_new ();
	_g_key_file_unref0 (self->priv->key);
	self->priv->key = _tmp6_;
	_tmp7_ = self->priv->key;
	g_key_file_set_list_separator (_tmp7_, ';');
	return self;
}


static NotificationsSession* notifications_session_new (void) {
	return notifications_session_construct (NOTIFICATIONS_TYPE_SESSION);
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static inline void _g_list_free__g_object_unref0_ (GList* self) {
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}


GList* notifications_session_get_session_notifications (NotificationsSession* self) {
	GList* result = NULL;
	GList* list = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	list = NULL;
	{
		GKeyFile* _tmp0_;
		GFile* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GKeyFile* _tmp4_;
		gsize _tmp5_;
		gchar** _tmp6_;
		_tmp0_ = self->priv->key;
		_tmp1_ = self->priv->session_file;
		_tmp2_ = g_file_get_path (_tmp1_);
		_tmp3_ = _tmp2_;
		g_key_file_load_from_file (_tmp0_, _tmp3_, G_KEY_FILE_NONE, &_inner_error_);
		_g_free0 (_tmp3_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch11_g_key_file_error;
			}
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch11_g_file_error;
			}
			__g_list_free__g_object_unref0_0 (list);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp4_ = self->priv->key;
		_tmp6_ = g_key_file_get_groups (_tmp4_, &_tmp5_);
		{
			gchar** group_collection = NULL;
			gint group_collection_length1 = 0;
			gint _group_collection_size_ = 0;
			gint group_it = 0;
			group_collection = _tmp6_;
			group_collection_length1 = _tmp5_;
			for (group_it = 0; group_it < _tmp5_; group_it = group_it + 1) {
				const gchar* group = NULL;
				group = group_collection[group_it];
				{
					gchar* _tmp7_ = NULL;
					GKeyFile* _tmp8_;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_ = NULL;
					GKeyFile* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_ = NULL;
					GKeyFile* _tmp16_;
					const gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_ = NULL;
					GKeyFile* _tmp20_;
					const gchar* _tmp21_;
					gchar* _tmp22_;
					gchar** _tmp23_ = NULL;
					GKeyFile* _tmp24_;
					const gchar* _tmp25_;
					gsize _tmp26_;
					gchar** _tmp27_;
					gint _tmp23__length1;
					gint __tmp23__size_;
					gchar* _tmp28_ = NULL;
					GKeyFile* _tmp29_;
					const gchar* _tmp30_;
					gchar* _tmp31_;
					gint64 _tmp32_ = 0LL;
					GKeyFile* _tmp33_;
					const gchar* _tmp34_;
					gint64 _tmp35_;
					gchar* _tmp36_ = NULL;
					GKeyFile* _tmp37_;
					const gchar* _tmp38_;
					gchar* _tmp39_;
					NotificationsNotification* notification = NULL;
					const gchar* _tmp40_;
					gint _tmp41_;
					NotificationsNotification* _tmp42_;
					NotificationsNotification* _tmp43_;
					NotificationsNotification* _tmp44_;
					_tmp8_ = self->priv->key;
					_tmp9_ = group;
					_tmp10_ = g_key_file_get_string (_tmp8_, _tmp9_, NOTIFICATIONS_SESSION_APP_NAME_KEY, &_inner_error_);
					_tmp7_ = _tmp10_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
							goto __catch11_g_key_file_error;
						}
						if (_inner_error_->domain == G_FILE_ERROR) {
							goto __catch11_g_file_error;
						}
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						__g_list_free__g_object_unref0_0 (list);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
					_tmp12_ = self->priv->key;
					_tmp13_ = group;
					_tmp14_ = g_key_file_get_string (_tmp12_, _tmp13_, NOTIFICATIONS_SESSION_APP_ICON_KEY, &_inner_error_);
					_tmp11_ = _tmp14_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_free0 (_tmp7_);
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
							goto __catch11_g_key_file_error;
						}
						if (_inner_error_->domain == G_FILE_ERROR) {
							goto __catch11_g_file_error;
						}
						_g_free0 (_tmp7_);
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						__g_list_free__g_object_unref0_0 (list);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
					_tmp16_ = self->priv->key;
					_tmp17_ = group;
					_tmp18_ = g_key_file_get_string (_tmp16_, _tmp17_, NOTIFICATIONS_SESSION_SUMMARY_KEY, &_inner_error_);
					_tmp15_ = _tmp18_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_free0 (_tmp11_);
						_g_free0 (_tmp7_);
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
							goto __catch11_g_key_file_error;
						}
						if (_inner_error_->domain == G_FILE_ERROR) {
							goto __catch11_g_file_error;
						}
						_g_free0 (_tmp11_);
						_g_free0 (_tmp7_);
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						__g_list_free__g_object_unref0_0 (list);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
					_tmp20_ = self->priv->key;
					_tmp21_ = group;
					_tmp22_ = g_key_file_get_string (_tmp20_, _tmp21_, NOTIFICATIONS_SESSION_BODY_KEY, &_inner_error_);
					_tmp19_ = _tmp22_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_free0 (_tmp15_);
						_g_free0 (_tmp11_);
						_g_free0 (_tmp7_);
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
							goto __catch11_g_key_file_error;
						}
						if (_inner_error_->domain == G_FILE_ERROR) {
							goto __catch11_g_file_error;
						}
						_g_free0 (_tmp15_);
						_g_free0 (_tmp11_);
						_g_free0 (_tmp7_);
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						__g_list_free__g_object_unref0_0 (list);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
					_tmp24_ = self->priv->key;
					_tmp25_ = group;
					_tmp27_ = g_key_file_get_string_list (_tmp24_, _tmp25_, NOTIFICATIONS_SESSION_ACTIONS_KEY, &_tmp26_, &_inner_error_);
					_tmp23_ = _tmp27_;
					_tmp23__length1 = _tmp26_;
					__tmp23__size_ = _tmp23__length1;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_free0 (_tmp19_);
						_g_free0 (_tmp15_);
						_g_free0 (_tmp11_);
						_g_free0 (_tmp7_);
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
							goto __catch11_g_key_file_error;
						}
						if (_inner_error_->domain == G_FILE_ERROR) {
							goto __catch11_g_file_error;
						}
						_g_free0 (_tmp19_);
						_g_free0 (_tmp15_);
						_g_free0 (_tmp11_);
						_g_free0 (_tmp7_);
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						__g_list_free__g_object_unref0_0 (list);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
					_tmp29_ = self->priv->key;
					_tmp30_ = group;
					_tmp31_ = g_key_file_get_string (_tmp29_, _tmp30_, NOTIFICATIONS_SESSION_DESKTOP_ID_KEY, &_inner_error_);
					_tmp28_ = _tmp31_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (_tmp19_);
						_g_free0 (_tmp15_);
						_g_free0 (_tmp11_);
						_g_free0 (_tmp7_);
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
							goto __catch11_g_key_file_error;
						}
						if (_inner_error_->domain == G_FILE_ERROR) {
							goto __catch11_g_file_error;
						}
						_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (_tmp19_);
						_g_free0 (_tmp15_);
						_g_free0 (_tmp11_);
						_g_free0 (_tmp7_);
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						__g_list_free__g_object_unref0_0 (list);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
					_tmp33_ = self->priv->key;
					_tmp34_ = group;
					_tmp35_ = g_key_file_get_int64 (_tmp33_, _tmp34_, NOTIFICATIONS_SESSION_UNIX_TIME_KEY, &_inner_error_);
					_tmp32_ = _tmp35_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_free0 (_tmp28_);
						_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (_tmp19_);
						_g_free0 (_tmp15_);
						_g_free0 (_tmp11_);
						_g_free0 (_tmp7_);
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
							goto __catch11_g_key_file_error;
						}
						if (_inner_error_->domain == G_FILE_ERROR) {
							goto __catch11_g_file_error;
						}
						_g_free0 (_tmp28_);
						_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (_tmp19_);
						_g_free0 (_tmp15_);
						_g_free0 (_tmp11_);
						_g_free0 (_tmp7_);
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						__g_list_free__g_object_unref0_0 (list);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
					_tmp37_ = self->priv->key;
					_tmp38_ = group;
					_tmp39_ = g_key_file_get_string (_tmp37_, _tmp38_, NOTIFICATIONS_SESSION_SENDER_KEY, &_inner_error_);
					_tmp36_ = _tmp39_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_free0 (_tmp28_);
						_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (_tmp19_);
						_g_free0 (_tmp15_);
						_g_free0 (_tmp11_);
						_g_free0 (_tmp7_);
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
							goto __catch11_g_key_file_error;
						}
						if (_inner_error_->domain == G_FILE_ERROR) {
							goto __catch11_g_file_error;
						}
						_g_free0 (_tmp28_);
						_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (_tmp19_);
						_g_free0 (_tmp15_);
						_g_free0 (_tmp11_);
						_g_free0 (_tmp7_);
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
						__g_list_free__g_object_unref0_0 (list);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
					_tmp40_ = group;
					_tmp41_ = atoi (_tmp40_);
					_tmp42_ = notifications_notification_new_from_data ((guint32) _tmp41_, _tmp7_, _tmp11_, _tmp15_, _tmp19_, _tmp23_, _tmp23__length1, _tmp28_, _tmp32_, _tmp36_);
					notification = _tmp42_;
					_tmp43_ = notification;
					_tmp44_ = _g_object_ref0 (_tmp43_);
					list = g_list_append (list, _tmp44_);
					_g_object_unref0 (notification);
					_g_free0 (_tmp36_);
					_g_free0 (_tmp28_);
					_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (_tmp19_);
					_g_free0 (_tmp15_);
					_g_free0 (_tmp11_);
					_g_free0 (_tmp7_);
				}
			}
			group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
		}
	}
	goto __finally11;
	__catch11_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp45_;
		const gchar* _tmp46_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp45_ = e;
		_tmp46_ = _tmp45_->message;
		g_warning ("Session.vala:76: %s", _tmp46_);
		_g_error_free0 (e);
	}
	goto __finally11;
	__catch11_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp47_;
		const gchar* _tmp48_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp47_ = e;
		_tmp48_ = _tmp47_->message;
		g_warning ("Session.vala:78: %s", _tmp48_);
		_g_error_free0 (e);
	}
	__finally11:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		__g_list_free__g_object_unref0_0 (list);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = list;
	return result;
}


void notifications_session_add_notification (NotificationsSession* self, NotificationsNotification* notification) {
	gchar* id = NULL;
	NotificationsNotification* _tmp0_;
	guint32 _tmp1_;
	gchar* _tmp2_;
	GKeyFile* _tmp3_;
	NotificationsNotification* _tmp4_;
	const gchar* _tmp5_;
	GKeyFile* _tmp6_;
	NotificationsNotification* _tmp7_;
	const gchar* _tmp8_;
	GKeyFile* _tmp9_;
	NotificationsNotification* _tmp10_;
	const gchar* _tmp11_;
	GKeyFile* _tmp12_;
	NotificationsNotification* _tmp13_;
	const gchar* _tmp14_;
	GKeyFile* _tmp15_;
	NotificationsNotification* _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	GKeyFile* _tmp18_;
	NotificationsNotification* _tmp19_;
	const gchar* _tmp20_;
	GKeyFile* _tmp21_;
	NotificationsNotification* _tmp22_;
	gint64 _tmp23_;
	GKeyFile* _tmp24_;
	NotificationsNotification* _tmp25_;
	const gchar* _tmp26_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (notification != NULL);
	_tmp0_ = notification;
	_tmp1_ = _tmp0_->id;
	_tmp2_ = g_strdup_printf ("%u", _tmp1_);
	id = _tmp2_;
	_tmp3_ = self->priv->key;
	_tmp4_ = notification;
	_tmp5_ = _tmp4_->app_name;
	g_key_file_set_string (_tmp3_, id, NOTIFICATIONS_SESSION_APP_NAME_KEY, _tmp5_);
	_tmp6_ = self->priv->key;
	_tmp7_ = notification;
	_tmp8_ = _tmp7_->app_icon;
	g_key_file_set_string (_tmp6_, id, NOTIFICATIONS_SESSION_APP_ICON_KEY, _tmp8_);
	_tmp9_ = self->priv->key;
	_tmp10_ = notification;
	_tmp11_ = _tmp10_->summary;
	g_key_file_set_string (_tmp9_, id, NOTIFICATIONS_SESSION_SUMMARY_KEY, _tmp11_);
	_tmp12_ = self->priv->key;
	_tmp13_ = notification;
	_tmp14_ = _tmp13_->message_body;
	g_key_file_set_string (_tmp12_, id, NOTIFICATIONS_SESSION_BODY_KEY, _tmp14_);
	_tmp15_ = self->priv->key;
	_tmp16_ = notification;
	_tmp17_ = _tmp16_->actions;
	_tmp17__length1 = _tmp16_->actions_length1;
	g_key_file_set_string_list (_tmp15_, id, NOTIFICATIONS_SESSION_ACTIONS_KEY, (const gchar* const*) _tmp17_, _tmp17__length1);
	_tmp18_ = self->priv->key;
	_tmp19_ = notification;
	_tmp20_ = _tmp19_->desktop_id;
	g_key_file_set_string (_tmp18_, id, NOTIFICATIONS_SESSION_DESKTOP_ID_KEY, _tmp20_);
	_tmp21_ = self->priv->key;
	_tmp22_ = notification;
	_tmp23_ = _tmp22_->unix_time;
	g_key_file_set_int64 (_tmp21_, id, NOTIFICATIONS_SESSION_UNIX_TIME_KEY, _tmp23_);
	_tmp24_ = self->priv->key;
	_tmp25_ = notification;
	_tmp26_ = _tmp25_->sender;
	g_key_file_set_string (_tmp24_, id, NOTIFICATIONS_SESSION_SENDER_KEY, _tmp26_);
	notifications_session_write_contents (self);
	_g_free0 (id);
}


void notifications_session_remove_notification (NotificationsSession* self, NotificationsNotification* notification) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (notification != NULL);
	{
		GKeyFile* _tmp0_;
		NotificationsNotification* _tmp1_;
		guint32 _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp0_ = self->priv->key;
		_tmp1_ = notification;
		_tmp2_ = _tmp1_->id;
		_tmp3_ = g_strdup_printf ("%u", _tmp2_);
		_tmp4_ = _tmp3_;
		g_key_file_remove_group (_tmp0_, _tmp4_, &_inner_error_);
		_g_free0 (_tmp4_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch12_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally12;
	__catch12_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		g_warning ("Session.vala:102: %s", _tmp6_);
		_g_error_free0 (e);
	}
	__finally12:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	notifications_session_write_contents (self);
}


void notifications_session_clear (NotificationsSession* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GFile* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = self->priv->session_file;
		_tmp1_ = g_file_get_path (_tmp0_);
		_tmp2_ = _tmp1_;
		g_file_set_contents (_tmp2_, "", (gssize) -1, &_inner_error_);
		_g_free0 (_tmp2_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch13_g_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally13;
	__catch13_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("Session.vala:112: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally13:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void notifications_session_create_session_file (NotificationsSession* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GFile* _tmp0_;
		GFileOutputStream* _tmp1_;
		GFileOutputStream* _tmp2_;
		_tmp0_ = self->priv->session_file;
		_tmp1_ = g_file_create (_tmp0_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error_);
		_tmp2_ = _tmp1_;
		_g_object_unref0 (_tmp2_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch14_g_error;
		}
	}
	goto __finally14;
	__catch14_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("Session.vala:120: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally14:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void notifications_session_write_contents (NotificationsSession* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GFile* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GKeyFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp0_ = self->priv->session_file;
		_tmp1_ = g_file_get_path (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = self->priv->key;
		_tmp4_ = g_key_file_to_data (_tmp3_, NULL, NULL);
		_tmp5_ = _tmp4_;
		g_file_set_contents (_tmp2_, _tmp5_, (gssize) -1, &_inner_error_);
		_g_free0 (_tmp5_);
		_g_free0 (_tmp2_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch15_g_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally15;
	__catch15_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		g_warning ("Session.vala:128: %s", _tmp7_);
		_g_error_free0 (e);
	}
	__finally15:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void notifications_session_class_init (NotificationsSessionClass * klass) {
	notifications_session_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NotificationsSessionPrivate));
	G_OBJECT_CLASS (klass)->finalize = notifications_session_finalize;
}


static void notifications_session_instance_init (NotificationsSession * self) {
	self->priv = NOTIFICATIONS_SESSION_GET_PRIVATE (self);
	self->priv->session_file = NULL;
}


static void notifications_session_finalize (GObject * obj) {
	NotificationsSession * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOTIFICATIONS_TYPE_SESSION, NotificationsSession);
	_g_object_unref0 (self->priv->session_file);
	_g_key_file_unref0 (self->priv->key);
	G_OBJECT_CLASS (notifications_session_parent_class)->finalize (obj);
}


GType notifications_session_get_type (void) {
	static volatile gsize notifications_session_type_id__volatile = 0;
	if (g_once_init_enter (&notifications_session_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NotificationsSessionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notifications_session_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotificationsSession), 0, (GInstanceInitFunc) notifications_session_instance_init, NULL };
		GType notifications_session_type_id;
		notifications_session_type_id = g_type_register_static (G_TYPE_OBJECT, "NotificationsSession", &g_define_type_info, 0);
		g_once_init_leave (&notifications_session_type_id__volatile, notifications_session_type_id);
	}
	return notifications_session_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



